/**
 * This class will be used as the basis for all the other randomizer classes, but can
 * never be instantiated itself because it is abstract, which means that, somewhat
 * like an interface, it has methods that are incomplete. Unlike an interface though,
 * it MAY habe instance variables and complete methods.
 * @author Aaron Braskin
 * @version February 19th, 2015
 */
public abstract class AbstractRandomizer implements Randomizer {
	private int sideUp;

	// Getters
	abstract public int getPossibleOutcomes();
	public int getCurrentValue() {
		return sideUp;
	}
	abstract public String getCurrentFace();

	// Setters (or Mutators)
	public void randomize() {
		sideUp=(int)(Math.random()*getPossibleOutcomes())+1;
	}
}