import java.awt.Color;
import java.awt.Component;
import java.awt.EventQueue;
import java.awt.Font;

import javax.swing.Timer;
import javax.swing.JFrame;

import java.awt.GridBagLayout;

import javax.swing.JButton;

import java.awt.GridBagConstraints;

import javax.swing.JLabel;

import java.awt.Insets;

import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;

import sun.audio.AudioPlayer;
import sun.audio.AudioStream;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;

import javax.swing.JTextField;
import javax.swing.JTextArea;


public class BoggleApp {

	private JFrame frame;
	private JTable table;
	private BoggleBoard bb;
	private JLabel lblTimer;
	private int tCounter=0;
	private boolean jumbleDice=false;
	private boolean countDown=false;
	private int secondsPerRound=6;
	private int secondsRemaining=secondsPerRound;
	private String audioFile = "AirHorn.wav";
	private InputStream in;
	private AudioStream audioStream;
	private JTextField textFieldTimer;
	private JButton btnBoggle;
	private JLabel lblWordsFound;
	private JTextArea textArea;
	private JButton btnAddWord;
	private JButton btnClearWord;
	private JLabel lblWord;
	private JTextField wordTextField;
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					BoggleApp window = new BoggleApp();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public BoggleApp() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frame = new JFrame();
		frame.setBounds(100, 100, 477, 347);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{0, 0, 0, 0, 0};
		gridBagLayout.rowHeights = new int[]{0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{1.0, 0.0, 1.0, 1.0, Double.MIN_VALUE};
		gridBagLayout.rowWeights = new double[]{0.0, 1.0, 0.0, Double.MIN_VALUE};
		frame.getContentPane().setLayout(gridBagLayout);

		btnBoggle = new JButton("Boggle!");
		btnBoggle.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				jumbleDice=true;
			}
		});
		GridBagConstraints gbc_btnBoggle = new GridBagConstraints();
		gbc_btnBoggle.fill = GridBagConstraints.HORIZONTAL;
		gbc_btnBoggle.insets = new Insets(0, 0, 5, 5);
		gbc_btnBoggle.gridx = 0;
		gbc_btnBoggle.gridy = 0;
		frame.getContentPane().add(btnBoggle, gbc_btnBoggle);

		table = new JTable();
		GridBagConstraints gbc_table = new GridBagConstraints();
		gbc_table.insets = new Insets(0, 0, 5, 5);
		gbc_table.gridwidth = 3;
		gbc_table.fill = GridBagConstraints.BOTH;
		gbc_table.gridx = 0;
		gbc_table.gridy = 1;
		bb=new BoggleBoard();
		String[][] data=new String[bb.getRows()][bb.getCols()];
		for (int r=0; r<bb.getRows(); r++) {
			for (int c=0; c<bb.getCols(); c++) {
				data[r][c]=bb.getBoggleDie(r, c).getCurrentFace();
			}
		}
		DefaultTableCellRenderer r = new DefaultTableCellRenderer() {
			private static final long serialVersionUID = 1L;

			public Component getTableCellRendererComponent(JTable table, Object
					value, boolean isSelected, boolean hasFocus, int row, int column) {
				super.getTableCellRendererComponent(
						table, value, isSelected, hasFocus, row, column);
				setHorizontalAlignment(JLabel.CENTER);
				Color foreground, background;
				if (isSelected) {
					foreground = Color.WHITE;
					background = Color.BLACK;
					if (hasFocus) {
						wordTextField.setText(wordTextField.getText()+bb.getBoggleDie(row, column).getCurrentFace());
					}
				}  else {
					foreground = Color.BLACK;
					background = Color.WHITE;
				}
				this.setForeground(foreground);
				this.setBackground(background);
				return this;
			}
		};
		Object[] titles={"1","2","3","4"};
		table = new JTable(data, titles);
		table.setSelectionMode(javax.swing.ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		//		table.getColumnModel().setColumnSelectionAllowed(false); 
		table.setRowSelectionAllowed(true);
		table.setColumnSelectionAllowed(true);
		for (int i=0; i<table.getColumnCount(); i++) {
			table.getColumnModel().getColumn(i).setCellRenderer(r);
		}
		//table.setRowSelectionAllowed(false);
		table.setEnabled(true);
		int fontSize=64;

		lblTimer = new JLabel("Time: ");
		GridBagConstraints gbc_lblWordsFound = new GridBagConstraints();
		gbc_lblWordsFound.anchor = GridBagConstraints.EAST;
		gbc_lblWordsFound.insets = new Insets(0, 0, 5, 5);
		gbc_lblWordsFound.gridx = 1;
		gbc_lblWordsFound.gridy = 0;
		frame.getContentPane().add(lblTimer, gbc_lblWordsFound);

		textFieldTimer = new JTextField();
		GridBagConstraints gbc_textFieldTimer = new GridBagConstraints();
		gbc_textFieldTimer.insets = new Insets(0, 0, 5, 5);
		gbc_textFieldTimer.fill = GridBagConstraints.HORIZONTAL;
		gbc_textFieldTimer.gridx = 2;
		gbc_textFieldTimer.gridy = 0;
		frame.getContentPane().add(textFieldTimer, gbc_textFieldTimer);
		textFieldTimer.setColumns(10);
		textFieldTimer.setText(""+this.secondsPerRound);

		lblWordsFound = new JLabel("Words Found:");
		GridBagConstraints gbc_lblWordsFound1 = new GridBagConstraints();
		gbc_lblWordsFound1.insets = new Insets(0, 0, 5, 0);
		gbc_lblWordsFound1.gridx = 3;
		gbc_lblWordsFound1.gridy = 0;
		frame.getContentPane().add(lblWordsFound, gbc_lblWordsFound1);
		table.setRowHeight(fontSize);
		table.setFont(new Font("Arial", Font.BOLD, fontSize));
		frame.getContentPane().add(table, gbc_table);

		textArea = new JTextArea();
		GridBagConstraints gbc_textArea = new GridBagConstraints();
		gbc_textArea.insets = new Insets(0, 0, 5, 0);
		gbc_textArea.fill = GridBagConstraints.BOTH;
		gbc_textArea.gridx = 3;
		gbc_textArea.gridy = 1;
		frame.getContentPane().add(textArea, gbc_textArea);

		btnClearWord = new JButton("Clear Word");
		btnClearWord.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				table.getSelectionModel().clearSelection();
				wordTextField.setText("");
			}
		});
		GridBagConstraints gbc_btnClearWord = new GridBagConstraints();
		gbc_btnClearWord.insets = new Insets(0, 0, 0, 5);
		gbc_btnClearWord.gridx = 0;
		gbc_btnClearWord.gridy = 2;
		frame.getContentPane().add(btnClearWord, gbc_btnClearWord);

		lblWord = new JLabel("Word:");
		GridBagConstraints gbc_lblWord = new GridBagConstraints();
		gbc_lblWord.anchor = GridBagConstraints.EAST;
		gbc_lblWord.insets = new Insets(0, 0, 0, 5);
		gbc_lblWord.gridx = 1;
		gbc_lblWord.gridy = 2;
		frame.getContentPane().add(lblWord, gbc_lblWord);

		wordTextField = new JTextField();
		GridBagConstraints gbc_wordTextField = new GridBagConstraints();
		gbc_wordTextField.insets = new Insets(0, 0, 0, 5);
		gbc_wordTextField.fill = GridBagConstraints.HORIZONTAL;
		gbc_wordTextField.gridx = 2;
		gbc_wordTextField.gridy = 2;
		frame.getContentPane().add(wordTextField, gbc_wordTextField);
		wordTextField.setColumns(10);

		btnAddWord = new JButton("Add Word");
		btnAddWord.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				String word=wordTextField.getText();
				table.getSelectionModel().clearSelection();
				if (word.length()>0) {
					String words=textArea.getText();
					if (words.length()>0) words+="\n";
					textArea.setText(words+word);
					wordTextField.setText("");
				}
			}
		});
		GridBagConstraints gbc_btnAddWord = new GridBagConstraints();
		gbc_btnAddWord.gridx = 3;
		gbc_btnAddWord.gridy = 2;
		frame.getContentPane().add(btnAddWord, gbc_btnAddWord);
		startClock();
	}
	private void updateTable() {
		bb.randomize();
		for (int r=0; r<bb.getRows(); r++) {
			for (int c=0; c<bb.getCols(); c++) {
				table.setValueAt(bb.getBoggleDie(r, c).getCurrentFace(),r,c);
			}
		}
	}
	public void startClock() { 

		class EventTimer implements ActionListener { // Note: a class within a method
			private int jumbleCount=0;
			public void actionPerformed(ActionEvent event)  { 
				if (jumbleDice) {
					if (jumbleCount==0) {
						table.getSelectionModel().clearSelection();
					}
					btnBoggle.setEnabled(false);
					textFieldTimer.setEnabled(false);
					btnAddWord.setEnabled(false);
					btnClearWord.setEnabled(false);
					wordTextField.setText("");
					wordTextField.setEnabled(false);
					textArea.setText("");
					textArea.setEnabled(false);

					updateTable();
					jumbleCount++;
					if (jumbleCount>5) {
						jumbleCount=0;
						jumbleDice=false;
						countDown=true;
						tCounter=0;
						lblTimer.setText("Time Remaining:");
						try {
							secondsPerRound=Integer.parseInt(textFieldTimer.getText());
						} catch (NumberFormatException e) {

						}

						secondsRemaining=secondsPerRound;
					}
				}
				if (countDown) {
					tCounter++;
					if (tCounter%10==0) {
						secondsRemaining--;
						textFieldTimer.setText(""+secondsRemaining);
						if (secondsRemaining<1) {
							try {
								in = new FileInputStream(audioFile);
								audioStream = new AudioStream(in);		 
								AudioPlayer.player.start(audioStream);
							} catch (FileNotFoundException e) {
								e.printStackTrace();
							} catch (IOException e) {
								e.printStackTrace();
							}
							countDown=false;
							lblTimer.setText("        Times Up!");
							textFieldTimer.setText(""+secondsPerRound);
							textFieldTimer.setEnabled(true);
							btnBoggle.setEnabled(true);
							lblTimer.setEnabled(true);
							btnAddWord.setEnabled(true);
							btnClearWord.setEnabled(true);
							wordTextField.setEnabled(true);
							textArea.setEnabled(true);
						}
					}
				}
			}
		} 
		EventTimer listener = new EventTimer();
		Timer t = new Timer(100, listener);  // 100 is the # of milliseconds to wait 
		t.start(); 
	}
}
