public class BoggleBoard {
	// Instance Variables
	private BoggleDie[][] boggleDice;
	private int rows, cols;
	
	// Constructor Methods
	public BoggleBoard() {
		rows=4;
		cols=4;
		int dieIndex=0;
		String[] bLettersArr={"AAEEGN","ELRTTY","AOOTTW","ABBJOO",
				"EHRTVN","CIMOTU","DISTTY","EIOSST","DELRVY",
				"ACHOPS","HIMNQU","EEINSU","EEGHNW",
				"AFFKPS","HLNNRZ","DEILRX"};
		boggleDice=new BoggleDie[rows][cols];
		for (int row=0; row<rows; row++) {
			for (int col=0; col<cols; col++) {
				boggleDice[row][col]=new BoggleDie(bLettersArr[dieIndex++]);
			}
		}
	}
	// Getter Methods
	public int getRows() {
		return rows;
	}
	public int getCols() {
		return cols;
	}
	public BoggleDie getBoggleDie(int row, int col) {
		if (row>=0 && row<getRows() && col>=0 && col<getCols()) {
			return boggleDice[row][col];
		}
		return null;
	}
	public String toString() {
		String s="";
		for (int r=0; r<getRows(); r++) {
			for (int c=0; c<getCols(); c++) {
				s+=getBoggleDie(r,c).getCurrentFace();
			}
			s+="\n";
		}
		return s;
	}
	// Setter Methods
	public void randomize() {
		for (int i=0; i<100; i++) {
			int r1=(int)(Math.random()*getRows());
			int c1=(int)(Math.random()*getCols());
			int r2=(int)(Math.random()*getRows());
			int c2=(int)(Math.random()*getCols());
			BoggleDie temp=boggleDice[r1][c1];
			boggleDice[r1][c1]=boggleDice[r2][c2];
			boggleDice[r2][c2]=temp;
			boggleDice[r1][c1].randomize();
			boggleDice[r2][c2].randomize();
		}
	}
}








